LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.NUMERIC_STD.ALL;

ENTITY mux0 IS
	PORT (
		I,Q : IN std_logic_vector(2 downto 0);
		SIG : IN std_logic_vector (18 downto 0);
		S : IN std_logic;
		CNAL,CNAR : OUT std_logic_vector (23 downto 0)
		);
END mux0;

ARCHITECTURE comport OF mux0 IS
	BEGIN
	PROCESS(S)
	BEGIN
	if (S='0') then
		CNAL <= SIG & "00000" ;
		CNAR <= SIG & "00000" ;
	else
		if (I="111") then
			CNAR <= "100000000000000000000000";
		elsif (I="000") then
			CNAR <= "000000000000000000000000";
		elsif (I="001") then
			CNAR <= "011111111111111111111111";
		elsif (Q="111") then
			CNAL <= "100000000000000000000000";
		elsif (Q="000") then
			CNAL <= "000000000000000000000000";
		elsif (Q="001") then
			CNAL <= "011111111111111111111111";
		end if;
	end if;
	END PROCESS;
END comport;
